/*
קוד דוגמא להתממשקות למערכת invoice4u
על בסיס : c# .net
*/
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using APITest.InvoiceLoginService;
using APITest.InvoiceDocumentService;
using APITest.InvoiceCustomerService;


namespace APITest
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            // Login and get a uniqe(GUID) token
            LoginServiceClient lsc = new LoginServiceClient();
            string token = lsc.VerifyLogin("test@test.com","123456",false);

           // APITest.InvoiceCustomerService.Customer client = CreateCustomer(token); 
            
            DocumentServiceClient dsc = new DocumentServiceClient();

            Document doc = dsc.CreateDocument(new Document()
            {
                ClientID = 71027,   //Can be client.ID 
                DocumentType = (int)DocumentType.InvoiceOrder,
                Subject = "Test123",
                Currency = "ILS",
                IssueDate = DateTime.Now, // can be at the Past no erlier then last invoice
                TaxIncluded = true, // means that the item price allready include tax, for example: if item Price = 118 ,so item Total = 118 and item TotalWithoutTax = 100 (in case that TaxPercentage = 18)
                
				Items = new InvoiceDocumentService.DocumentItem[]{
                            new InvoiceDocumentService.DocumentItem(){
                                Code="001",
                                Name="first Item",
                                Quantity=1,
                                Price=10,
								//TaxPercentage=0, // in case you want an item without tax 
                            },
				},
				
				Discount = new APITest.InvoiceDocumentService.Discount { 
                    Value = 5, 
                    IsNominal = true, // means that the discount is calculated according to currency type (in this case: 5 ILS), if it is false than discount calculated in percentages (in this case: 5%)
                    BeforeTax = true, // discount calculated before tax calculated
                },
				
                AssociatedEmails = new AssociatedEmail[]{
                                    new AssociatedEmail(){ 
                                        Mail="oren@mashiktech.com",
                                        IsUserMail=true, // means that this is the user email, and this is the email that sends the document to all associated email  
									},
									new AssociatedEmail(){ 
                                        Mail="yariv@mashiktech.com",
                                        IsUserMail=false, 
									},
									new AssociatedEmail(){ 
                                        Mail="mor@mashiktech.com",
                                        IsUserMail=false,  
									},
                },
            }
            , token);

            if (doc.Errors.Length > 0)
                //..... Log the doc.Errors[0].Error
                return ;
            else
                //..... Succsesss
                return;
        }

        private InvoiceCustomerService.Customer CreateCustomer(string token)
        {
            CustomerServiceClient csc = new CustomerServiceClient();
            APITest.InvoiceCustomerService.Customer newCustomer = new APITest.InvoiceCustomerService.Customer();
            newCustomer.Name = "New Client";
            newCustomer.Email = "Testing@testing.com";
            newCustomer.UniqueID = "064558083";
            newCustomer.PayTerms = 30;
            newCustomer.Phone = "0465422356";
            newCustomer.Fax = "046588689";
            newCustomer.Cell = "0522256664";
            newCustomer.Active = true;
            newCustomer.Address = "הרחוב הראשי";
            newCustomer.City = "עיר חשובה";
            newCustomer.Zip = "523367";

            return csc.Create(newCustomer, token);
        }
    }
}
