/*
    invoice4u
  : c# .net
*/
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using APITest.InvoiceLoginService;
using APITest.InvoiceDocumentService;
using APITest.InvoiceCustomerService;


namespace APITest
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            // Login and get a uniqe(GUID) token
            LoginServiceClient lsc = new LoginServiceClient();
            string token = lsc.VerifyLogin("test@test.com","123456",false);

           // APITest.InvoiceCustomerService.Customer client = CreateCustomer(token);
            
            DocumentServiceClient dsc = new DocumentServiceClient();

            Document doc = dsc.CreateDocument(new Document()
            {
                ClientID = 71027,   //Can be client.ID 
                                    // --------OR--------
                                    //GeneralCustomer = new GeneralCustomer {
                                    //	                    Identifier="0665445262",
                                    //	                    Name="Some Name"
                                    //                      }
                DocumentType = (int)DocumentType.InvoiceReceipt,                
                Subject="Test123",
				Currency = "ILS",
                IssueDate=DateTime.Now,
				TaxIncluded = true, // means that the item price allready include tax, for example: if item Price = 118 ,so item Total = 118 and item TotalWithoutTax = 100 (in case that TaxPercentage = 18)
                
				Items = new APITest.InvoiceDocumentService.DocumentItem[]{
                            new APITest.InvoiceDocumentService.DocumentItem(){
                            Code="001",
			                Name="first Item",
			                Quantity=10.00,
			                Price=11,
							//TaxPercentage=0, // in case you want an item without tax
				            Discount= new APITest.InvoiceDocumentService.Discount{
									IsNominal=true, // means that the discount is calculated according to currency type (in this case: 1 ILS), if it is false than discount calculated in percentages (in this case: 1%)
									Value=1
								}
                            },
                            new APITest.InvoiceDocumentService.DocumentItem(){
                            Code="002",
			                Name="second item",
			                Quantity=20.00,
			                Price=22,
							//TaxPercentage=0, // in case you want an item without tax
				            Discount= new APITest.InvoiceDocumentService.Discount{
									IsNominal=true, // means that the discount is calculated according to currency type (in this case: 2 ILS), if it is false than discount calculated in percentages (in this case: 2%)
									Value=2
								}
                            },
                            new APITest.InvoiceDocumentService.DocumentItem(){
                            Code="003",
			                Name="third item",
			                Quantity=30.00,
			                Price=33,
							//TaxPercentage=0, // in case you want an item without tax
				            Discount= new APITest.InvoiceDocumentService.Discount{
									IsNominal=true, // means that the discount is calculated according to currency type (in this case: 3 ILS), if it is false than discount calculated in percentages (in this case: 3%)
									Value=3
								}
                            }, 
                },
				
                Discount = new APITest.InvoiceDocumentService.Discount{
                    Value = 40, 
                    IsNominal = true, // means that the discount is calculated according to currency type (in this case: 40 ILS), if it is false than discount calculated in percentages (in this case: 40%)
                    BeforeTax = true, // discount calculated before tax calculated
                },
				
                Payments = new Payment[]{ 
							new Payment(){
								Date=DateTime.Now,
								Amount=1485.72,
								PaymentType= (int)PaymentTypes.Cash,
                            },
							// --------OR--------
							//new Payment(){
							//    Date=DateTime.Now,
							//    Amount=1485.72,
							//    PaymentType= (int)PaymentTypes.CreditCard,
							//    NumberOfPayments = 1,
							//    PaymentNumber  = "6666",  // card number
							//    CreditCardName="aaa",  // card type
							//    ExpirationDate ="05/15",  // car exp. date
							//    PayerID = "*********"  
							//},
							// --------OR--------
							//new Payment(){
							//    Date=DateTime.Now,
							//    Amount=1485.72,
							//    PaymentType= (int)PaymentTypes.Check,
							//    AccountNumber = "******",  
							//    BankName = "leumi",
							//    BranchName = "737",
							//    PaymentNumber = "5",
							//},
							// --------OR--------
							//new Payment(){
							//    Date=DateTime.Now,
							//    Amount=1485.72,
							//    PaymentType= (int)PaymentTypes.MoneyTransfer,
							//    AccountNumber = "******",
							//    BankName = "leumi",
							//    BranchName = "737",
							//},
							// --------OR--------
							//new Payment(){
                            //    Date=DateTime.Now,
                            //    Amount=1485.72,
                            //    PaymentType= (int)PaymentTypes.Credit,  
                            //},
				},
				
				AssociatedEmails = new AssociatedEmail[]{
                                    new AssociatedEmail(){ 
                                        Mail="oren@mashiktech.com",
                                        IsUserMail=true, // means that this is the user email, and this is the email that sends the document to all associated email  
									},
									new AssociatedEmail(){ 
                                        Mail="yariv@mashiktech.com",
                                        IsUserMail=false, 
									},
									new AssociatedEmail(){ 
                                        Mail="mor@mashiktech.com",
                                        IsUserMail=false,  
									},
                },
            }
            , token);

            if (doc.Errors.Length > 0)
                //..... Log the doc.Errors[0].Error
                return ;
            else
                //..... Succsesss
                return;
        }

        private InvoiceCustomerService.Customer CreateCustomer(string token)
        {
            CustomerServiceClient csc = new CustomerServiceClient();
            APITest.InvoiceCustomerService.Customer newCustomer = new APITest.InvoiceCustomerService.Customer();
            newCustomer.Name = "New Client";
            newCustomer.Email = "Testing@testing.com";
            newCustomer.UniqueID = "064558083";
            newCustomer.PayTerms = 30;
            newCustomer.Phone = "0465422356";
            newCustomer.Fax = "046588689";
            newCustomer.Cell = "0522256664";
            newCustomer.Active = true;
            newCustomer.Address = " ";
            newCustomer.City = " ";
            newCustomer.Zip = "523367";
            // USE newCustomer.ID = xxxx in order to Edit exsting customer
            return csc.Create(newCustomer, token);
        }

    }
}
