/*
    invoice4u
  : c# .net
*/
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using APITest.InvoiceLoginService;
using APITest.InvoiceDocumentService;
using APITest.InvoiceCustomerService;


namespace APITest
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            // Login and get a uniqe(GUID) token
            LoginServiceClient lsc = new LoginServiceClient();
            string token = lsc.VerifyLogin("test@test.com","123456",false);

           // APITest.InvoiceCustomerService.Customer client = CreateCustomer(token);
            
            DocumentServiceClient dsc = new DocumentServiceClient();

            Document doc = dsc.CreateDocument(new Document()
            {
                ClientID = 71027,   //Can be client.ID 
                DocumentType = (int)DocumentType.Receipt,
                Subject = "Test123",
                Currency = "ILS",
                IssueDate = DateTime.Now, // can be at the Past no erlier then last invoice
				/******************* in case you want to create receipt to specific invoices
                Invoices = GetInvoices(token, 10.00, DocumentType.Receipt), 
                DocumentReffType = (int)DocumentType.Invoice,
				********************/
				
		        Payments = new Payment[]{ 
							new Payment(){
								Date = DateTime.Now,
								Amount=10.00,
								PaymentType= (int)PaymentTypes.Cash,
                            },
							// --------OR--------
							//new Payment(){
							//    Date=DateTime.Now,
							//    Amount=10,
							//    PaymentType= (int)PaymentTypes.CreditCard,
							//    NumberOfPayments = 1,
							//    PaymentNumber  = "6666",  // card number
							//    CreditCardName="aaa",  // card type
							//    ExpirationDate ="05/15",  // car exp. date
							//    PayerID = "*********"  
							//},
							// --------OR--------
							//new Payment(){
							//    Date=DateTime.Now,
							//    Amount=10,
							//    PaymentType= (int)PaymentTypes.Check,
							//    AccountNumber = "******",  
							//    BankName = "leumi",
							//    BranchName = "737",
							//    PaymentNumber = "5",
							//},
							// --------OR--------
							//new Payment(){
							//    Date=DateTime.Now,
							//    Amount=10,
							//    PaymentType= (int)PaymentTypes.MoneyTransfer,
							//    AccountNumber = "******",
							//    BankName = "leumi",
							//    BranchName = "737",
							//},
							// --------OR--------
							//new Payment(){
                            //    Date=DateTime.Now,
                            //    Amount=10,
                            //    PaymentType= (int)PaymentTypes.Credit,  
                            //},
                },
				
				AssociatedEmails = new AssociatedEmail[]{
                                    new AssociatedEmail(){ 
                                        Mail="oren@mashiktech.com",
                                        IsUserMail=true, // means that this is the user email, and this is the email that sends the document to all associated email  
									},
									new AssociatedEmail(){ 
                                        Mail="yariv@mashiktech.com",
                                        IsUserMail=false, 
									},
									new AssociatedEmail(){ 
                                        Mail="mor@mashiktech.com",
                                        IsUserMail=false,  
									},
                },
            }
            , token);

            if (doc.Errors.Length > 0)
                //..... Log the doc.Errors[0].Error
                return ;
            else
                //..... Succsesss
                return;
        }

        private InvoiceCustomerService.Customer CreateCustomer(string token)
        {
            CustomerServiceClient csc = new CustomerServiceClient();
            APITest.InvoiceCustomerService.Customer newCustomer = new APITest.InvoiceCustomerService.Customer();
            newCustomer.Name = "New Client";
            newCustomer.Email = "Testing@testing.com";
            newCustomer.UniqueID = "064558083";
            newCustomer.PayTerms = 30;
            newCustomer.Phone = "0465422356";
            newCustomer.Fax = "046588689";
            newCustomer.Cell = "0522256664";
            newCustomer.Active = true;
            newCustomer.Address = " ";
            newCustomer.City = " ";
            newCustomer.Zip = "523367";

            return csc.Create(newCustomer, token);
        }

        private Document[] GetInvoices(string token, double sumToCredit , DocumentType documentType)
        {
            // Init array
            Document[] docs = new Document[1]; 
            //Get document to credit
            DocumentsRequest dr = new DocumentsRequest() {DocumentNumber = 10003,Type=DocumentType.Invoice,ReportType=ReportTypes.Document };
            docs[0] = new DocumentServiceClient().GetDocuments(dr, token).Response[0];
           //Set Credit Amount
            if (documentType == DocumentType.InvoiceCredit)
                docs[0].CreditAmount = sumToCredit; 
			docs[0].ReceiptAmount = sumToCredit;
            return docs;
        }
    }
}
