<?php

/** Invoice4U 911PC Ltd 17.07.2012 **/
header("Content-Type: text/plain");

class Document
{
    public $ClientID = 71027;
    public $DocumentType = 3;
    public $Subject = "Test123";
    public $Currency = "ILS";
    public $Total = 100;
    public $TotalWithoutTax = 100;
    public $TotalTaxAmount = 0;
    public $TaxPercentage = 0;
    public $ExternalComments = "";
    public $InternalComments = "";
    public $BranchID = 71;
    public $IssueDate;
    public $ConversionRate = 1;
    public $Discount;
    public $RoundAmount = 0;
    public $Language = 1;
    public $Items;
    public $AssociatedEmails;
    public $Payments;

    public function __construct()
    {
      $this->IssueDate = date('d/m/Y H:i:s');
      $this->Discount = new Discount;
      $this->Items = array(new Item());
      $this->AssociatedEmails = array(new Email());
      $this->Payments = array(new Payment());
    }
}
class Discount
{
    public $Value = 0;
    public $BeforeTax = true;
}
class Item
{
    public $Code = "001";
    public $Name = "first Item";
    public $Quantity = 1;
    public $Price = 100;
    public $Total = 100;
    public $TotalWithoutTax = 100;
    public $TaxPercentage = 0;
    public $Discount;

    public function __construct()
    {
      $this->Discount = new Discount;
    }
}
class Email
{
    public $Mail = "test@test.com";
    public $IsUserMail = true;
}
class Payment
{
    public $Date;
    public $Amount = 100;
    public $PaymentType = 4;

    public function __construct()
    {
      $this->Date = date('d/m/Y H:i:s');
    }
}

class Invoice4u
{
  public $token;
  public $result;

  private function requestWS($wsdl, $service, $params)
  {
    try
    {
      $options = array('trace' => true, 'exceptions' => true, 'cache_wsdl' => WSDL_CACHE_NONE, 'connection_timeout' => 10);

      $client = new SoapClient($wsdl, $options);

      //var_dump($client->__getTypes()); exit;

      $response = $client->$service($params);

      $service = $service . "Result";

      $this->result = $response->$service;

    } catch (SoapFault $f) {

      echo $f->faultstring;

    } catch (Exception $e) {

      echo $e->getMessage();
    }
  }

  public function Login()
  {
    $wsdl = "http://private.invoice4u.co.il/Services/LoginService.svc?wsdl";
    $user = array('username' => 'test@test.com', 'password' => '123456', 'isPersistent' => false);

    $this->requestWS($wsdl, "VerifyLogin", $user);
    $this->token = $this->result;
  }

  public function CreateDocument()
  {
    $wsdl = "http://private.invoice4u.co.il/Services/DocumentService.svc?wsdl";

    $doc = new Document();

    $this->result = $this->requestWS($wsdl, "CreateDocument", array('doc' => $doc, 'token' => $this->token));
  }
}

$invoice = new Invoice4u();
$invoice->Login();
$invoice->CreateDocument();

var_dump($invoice->result);

?>